#pragma once

typedef struct StructMetafileDetails
{
	long Width;
	long Height;
	long ResolutionX;
	long ResolutionY;
}   MetafileDetails, *pMetafileDetails;

BOOL GetMetafileDetails(HENHMETAFILE hEmf, pMetafileDetails pmd)
{	
	if (!hEmf)
		return FALSE;

	ENHMETAHEADER emh;
	ZeroMemory( &emh, sizeof(ENHMETAHEADER) );
	emh.nSize = sizeof(ENHMETAHEADER);
	if( GetEnhMetaFileHeader( hEmf, sizeof( ENHMETAHEADER ), &emh ) == 0 )
		return FALSE;

	LONG diff = abs(emh.rclFrame.right / 100 - emh.szlMillimeters.cx);
	if ((diff < 2) || (emh.rclBounds.left != 0))
		pmd->Width	= emh.szlDevice.cx;
	else
		pmd->Width	= emh.rclBounds.right;

	diff = abs(emh.rclFrame.bottom / 100 - emh.szlMillimeters.cy);
	if ((diff < 2) || (emh.rclBounds.top != 0))
		pmd->Height	= emh.szlDevice.cy;
	else
		pmd->Height	= emh.rclBounds.bottom;

	pmd->ResolutionX = (long)ceil((double)(pmd->Width  * 2540) / emh.rclFrame.right); 
	pmd->ResolutionY = (long)ceil((double)(pmd->Height * 2540) / emh.rclFrame.bottom);

	return TRUE;
}