// PlayMetafile.cpp : Defines the entry point for the console application.

#include "stdafx.h"
#include <math.h>
#include "MetafileDetails.h"

// set correct path to PDFCreatorPilot.dll in the line bellow
#import "path\\to\\PDFCreatorPilot.dll"
using namespace PDFCreatorPilotLib;

int _tmain(int argc, _TCHAR* argv[])
{
    ::CoInitialize(NULL);
    // declare PDF Creator Pilot object
    IPDFDocument4* PDF = NULL;

    CLSID clsid_PDFCreatorPilot;
    CLSIDFromProgID(OLESTR("PDFCreatorPilot.PDFDocument4"), &clsid_PDFCreatorPilot);
    ::CoCreateInstance(clsid_PDFCreatorPilot, NULL, CLSCTX_ALL, __uuidof(IPDFDocument4), (LPVOID*)&PDF);        
    if(PDF == NULL)
    {
        ::CoUninitialize();
        return 1;
    }

    PDF->SetLicenseData("demo","demo");

    _TCHAR* emfFile = "metafile.emf";
    HENHMETAFILE hEmf = GetEnhMetaFile(emfFile);

    MetafileDetails md = {0};
    if(!GetMetafileDetails(hEmf, &md))
    {
        ::CoUninitialize();
        return 2;
    }

    // Scale factor based on the resolutions difference
    double dScaleFactor = (double)PDF->PageResolution / (double)md.ResolutionY;

    PDF->PageHeight = (long)(md.Height * dScaleFactor);
    PDF->PageWidth  = (long)(md.Width * dScaleFactor);

    PDF->PlayMetaFile(emfFile, 0, 0, dScaleFactor, dScaleFactor);

    PDF->SaveToFile("PlayMetafile.pdf", true);

    ::CoUninitialize();
    return 0;
}
